Sunday, June 14, 2015

Two Sum | Leetcode

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

---

Solution: Store index of each sub-target number in the array into a hashmap. The sub-target number is equal to target - nums[i]. When we see a number that is equal to the sub-target number later, then return the answer. Note that the index is 1-based for this question.
public class Solution {
    public int[] twoSum(int[] nums, int target) {
        Map subTargetToIndex = new HashMap<>();
        for (int i = 0; i < nums.length; i++) {
            int n = nums[i];
            if (subTargetToIndex.containsKey(n)) {
                return new int[] { subTargetToIndex.get(n), i + 1 };
            }
            subTargetToIndex.put(target - n, i + 1);
        }
        return null;
    }
}

No comments: